#ifndef _GDT_
#define _GDT_

/**
 * Structure of a GDT entry
 */
struct GdtEntry {
	unsigned short limitLow;
	unsigned short baseLow;
	unsigned char baseMiddle;
	unsigned char access;
	unsigned char granularity;
	unsigned char baseHigh;
}__attribute__((packed));

/**
 * Structure of the GDT pointer
 */
struct GdtPointer {
	unsigned short limit;
	unsigned int base;
}__attribute__((packed));

/**
 * GdtMounter's method for mounting the global descriptor table
 */
extern "C" void _mountGdt();

class Gdt {
public:
	void install();
	void createGdtGate(int index, unsigned int base, unsigned int limit,
		unsigned char access, unsigned char granularity);
};
#endif
